=== src/CMakeLists.txt ===
add_sources(
    array.cpp
    basicackframe.h
    basiccancelframe.h
    basiccancelokframe.h
    basicconsumeframe.h
    basicconsumeokframe.h
    basicdeliverframe.h
    basicframe.h
    basicgetemptyframe.h
    basicgetframe.h
    basicgetokframe.h
    basicheaderframe.h
    basicnackframe.h
    basicpublishframe.h
    basicqosframe.h
    basicqosokframe.h
    basicrecoverasyncframe.h
    basicrecoverframe.h
    basicrecoverokframe.h
    basicrejectframe.h
    basicreturnframe.h
    bodyframe.h
    channelcloseframe.h
    channelcloseokframe.h
    channelflowframe.h
    channelflowokframe.h
    channelframe.h
    channelimpl.cpp
    channelopenframe.h
    channelopenokframe.h
    confirmselectframe.h
    confirmselectokframe.h
    connectioncloseframe.h
    connectioncloseokframe.h
    connectionframe.h
    connectionimpl.cpp
    connectionopenframe.h
    connectionopenokframe.h
    connectionsecureframe.h
    connectionsecureokframe.h
    connectionstartframe.h
    connectionstartokframe.h
    connectiontuneframe.h
    connectiontuneokframe.h
    consumedmessage.h
    deferredcancel.cpp
    deferredconfirm.cpp
    deferredconsumer.cpp
    deferredreceiver.cpp
    deferredextreceiver.cpp
    deferredrecall.cpp
    deferredget.cpp
    exchangebindframe.h
    exchangebindokframe.h
    exchangedeclareframe.h
    exchangedeclareokframe.h
    exchangedeleteframe.h
    exchangedeleteokframe.h
    exchangeframe.h
    exchangeunbindframe.h
    exchangeunbindokframe.h
    extframe.h
    field.cpp
    flags.cpp
    framecheck.h
    headerframe.h
    heartbeatframe.h
    includes.h
    methodframe.h
    passthroughbuffer.h
    protocolheaderframe.h
    queuebindframe.h
    queuebindokframe.h
    queuedeclareframe.h
    queuedeclareokframe.h
    queuedeleteframe.h
    queuedeleteokframe.h
    queueframe.h
    queuepurgeframe.h
    queuepurgeokframe.h
    queueunbindframe.h
    queueunbindokframe.h
    receivedframe.cpp
    reducedbuffer.h
    returnedmessage.h
    table.cpp
    transactioncommitframe.h
    transactioncommitokframe.h
    transactionframe.h
    transactionrollbackframe.h
    transactionrollbackokframe.h
    transactionselectframe.h
    transactionselectokframe.h
    watchable.cpp
)
